///**
// * @author 54chen(陈臻) [chenzhen@xiaomi.com czhttp@gmail.com]
// * @since 2011-3-9 上午11:43:42
// */
//
//package com.xiaomi.common.service.dal.routing;
//
//import java.util.Map;
//
//import javax.sql.DataSource;
//
//import net.paoding.rose.jade.annotation.ShardParam;
//import net.paoding.rose.jade.core.SQLThreadLocal;
//import net.paoding.rose.jade.exql.ExprResolver;
//import net.paoding.rose.jade.exql.impl.ExprResolverImpl;
//import net.paoding.rose.jade.provider.Modifier;
//import net.paoding.rose.jade.provider.SQLInterpreter;
//import net.paoding.rose.jade.provider.SQLInterpreterResult;
//
//import org.apache.commons.logging.Log;
//import org.apache.commons.logging.LogFactory;
//import org.springframework.core.annotation.Order;
//import org.springframework.dao.InvalidDataAccessApiUsageException;
//import org.springframework.jdbc.BadSqlGrammarException;
//
//import com.meidusa.amoeba.parser.dbobject.Column;
//import com.meidusa.amoeba.parser.dbobject.Table;
//
//@Order(9000)
//public class RouterInterpreter implements SQLInterpreter {
//    private static final Log logger = LogFactory.getLog(RouterInterpreter.class);
//
//    private RoutingConfigurator routingConfigurator;
//    @Override
//    public SQLInterpreterResult interpret(DataSource dataSource, String sql, Modifier modifier,
//            Map<String, Object> parametersAsMap, final Object[] parametersAsArray) {
//        SQLParseInfo parseInfo = SQLParseInfo.getParseInfo(sql);
//        // 从查询的数据表获取路由配置。
//        Table[] tables = parseInfo.getTables();
//
//        RoutingInfo routingInfo = null;
//        //
//        if (tables != null) {
//            int beginIndex = 0;
//            if (parseInfo.isInsert() && tables.length > 1) {
//                // INSERT ... SELECT 查询
//                beginIndex = 1;
//            }
//
//            // 查找散表配置
//            for (int i = beginIndex; i < tables.length; i++) {
//
//                // RoutingDescriptor descriptor = new RoutingDescriptor() {
//                //
//                // @Override
//                // public Router getTableRouter() {
//                // Router router = new Router() {
//                //
//                // @Override
//                // public String getColumn() {
//                // return "type";
//                // }
//                //
//                // @Override
//                // public String doRoute(Object columnValue) {
//                // return "analyze_result_" + columnValue;
//                // }
//                // };
//                // return router;
//                // }
//                //
//                // @Override
//                // public Router getDbRouter() {
//                // // TODO Auto-generated method stub
//                // return null;
//                // }
//                //
//                // @Override
//                // public String getDbName() {
//                // // TODO Auto-generated method stub
//                // return null;
//                // }
//                // };
//
//                RoutingDescriptor descriptor = routingConfigurator.getDescriptor(tables[i]
//                        .getName());
//                if (descriptor != null) {
//                    routingInfo = new RoutingInfo(tables[i], descriptor);
//                    break;
//                }
//            }
//        }
//        if (routingInfo == null) {
//            return null;
//        } else {
//            if (logger.isDebugEnabled()) {
//                logger.debug("Find routing info: " + routingInfo.byTable + ", "
//                        + routingInfo.getDbRouterColumn());
//            }
//        }
//
//        String forwardTableName = null;
//        //String forwardDbPattern = null;
//
//        if (routingInfo.getTableRouter() != null) {
//
//            // 用语句信息的常量进行散表。
//            Column column = routingInfo.getTableRouterColumn();
//            Object columnValue = null;
//
//            if (column != null) {
//                columnValue = findShardParamValue(parseInfo, column, parametersAsMap,
//                        parametersAsArray);
//                if (columnValue == null) {
//                    throw new BadSqlGrammarException("sharding", parseInfo.getSQL(), null);
//                }
//            }
//
//            // 获得散表的名称
//            forwardTableName = routingInfo.getTableRouter().doRoute(columnValue);
//        } else {
//            if (logger.isDebugEnabled()) {
//                logger.debug("table router is null for sql \"" + sql + "\"");
//            }
//        }
//
//        //
//        String byTableName = routingInfo.byTable.getName();
//        final String sqlRewrited;
//        if ((forwardTableName != null) && !forwardTableName.equals(byTableName)) {
//
//            // 使用 SqlRewriter 拆分语句，进行所需的查找和替换。
//            sqlRewrited = SqlRewriter.rewriteSqlTable(sql, byTableName, forwardTableName);
//
//            // 输出重写日志
//            if (logger.isDebugEnabled()) {
//                logger.debug("Rewriting SQL: \n  From: " + sql + "\n  To:   " + sqlRewrited);
//            }
//        } else {
//            sqlRewrited = sql;
//        }
//        return new SQLInterpreterResult() {
//
//            @Override
//            public String getSQL() {
//                return sqlRewrited;
//            }
//
//            @Override
//            public Object[] getParameters() {
//                return parametersAsArray;
//            }
//        };
//    }
//
//    class RoutingInfo {
//
//        private Table byTable;
//
//        private RoutingDescriptor descriptor;
//
//        public RoutingInfo(Table table, RoutingDescriptor descriptor) {
//            this.byTable = table;
//            this.descriptor = descriptor;
//        }
//
//        public Router getDbRouter() {
//            return descriptor.getDbRouter();
//        }
//
//        public Router getTableRouter() {
//            return descriptor.getTableRouter();
//        }
//
//        private Column dbRouterColumn;
//
//        public Column getDbRouterColumn() {
//            if (dbRouterColumn != null) {
//                return dbRouterColumn;
//            }
//            Router dbRouter = getDbRouter();
//            if (dbRouter == null) {
//                return null;
//            }
//
//            String columnName = dbRouter.getColumn();
//
//            if (columnName != null) {
//
//                // 保存匹配的数据列
//                Column columnForDBPartition = new Column();
//                columnForDBPartition.setName(columnName.toUpperCase());
//                columnForDBPartition.setTable(byTable);
//                this.dbRouterColumn = columnForDBPartition;
//            }
//            return dbRouterColumn;
//        }
//
//        private Column tableRouterColumn;
//
//        public Column getTableRouterColumn() {
//            if (tableRouterColumn != null) {
//                return tableRouterColumn;
//            }
//            Router tableRouter = getTableRouter();
//            if (tableRouter == null) {
//                return null;
//            }
//
//            String columnName = tableRouter.getColumn();
//
//            if (columnName != null) {
//
//                // 保存匹配的数据列
//                Column tableRouterColumn = new Column();
//                tableRouterColumn.setName(columnName.toUpperCase());
//                tableRouterColumn.setTable(byTable);
//                this.tableRouterColumn = tableRouterColumn;
//            }
//            return tableRouterColumn;
//        }
//    }
//
//    // 查找散表参数
//    protected static Object findShardParamValue(SQLParseInfo parseInfo, Column column,
//            Map<String, Object> parametersAsMap, Object[] parametersAsArray) {
//        SQLThreadLocal local = SQLThreadLocal.get();
//        Object value = null;
//
//        ShardParam shardParam = local.getModifier().getAnnotation(ShardParam.class);
//        if (shardParam != null) {
//            // 检查外部提供的散表参数
//            Column shardColumn = SQLParseInfo.newColumn(shardParam.name());
//
//            try {
//                ExprResolver exprResolver = new ExprResolverImpl(parametersAsMap);
//                value = exprResolver.executeExpr(shardParam.value());
//
//            } catch (Exception e) {
//                if (logger.isWarnEnabled()) {
//                    logger.warn("Can't execute @ShardParam expr: " + shardParam.value(), e);
//                }
//                throw new InvalidDataAccessApiUsageException("Can't execute @ShardParam expr: "
//                        + shardParam.value(), e);
//            }
//
//            if (ShardParam.WIDECARD.equals(shardColumn.getName())) {
//                // 匹配所有散表列
//                return value;
//
//            } else if (shardColumn.getTable() == null) {
//
//                // 模糊的匹配散表列
//                if (shardColumn.getName().equals(column.getName())) {
//                    return value;
//                }
//
//            } else if (shardColumn.equals(column)) {
//                // 精确的匹配散表列
//                return value;
//            }
//            // 如果针对该列进行散表，则必须包含该列作为查询条件。
//            throw new BadSqlGrammarException("interpreter.findShardParamValue@ShardParam", "SQL ["
//                    + parseInfo.getSQL() + "] Query without shard parameter: " // NL
//                    + column.getSql(), null);
//
//        } else if (parseInfo.containsParam(column)) {
//            // 获取语句中的散表参数
//            value = parseInfo.getParam(column);
//            if (value != null) {
//                if (logger.isDebugEnabled()) {
//                    logger.debug("find shard param value '" + value + "' by column "
//                            + column.getName() + " [constants]");
//                }
//            }
//            if (value == null) {
//                int index = parseInfo.getColumnIndex(column) - 1;
//                if (index >= 0 && index < parametersAsArray.length) {
//                    value = parametersAsArray[index];
//                    if (logger.isDebugEnabled()) {
//                        logger.debug("find shard param value '" + value + "' by column's arg "
//                                + column.getName() + " [index=" + index + " (beginwiths 0)]");
//                    }
//                } else {
//                    // 如果针对该列进行散表，则必须包含该列作为查询条件。
//                    throw new BadSqlGrammarException("interpreter.findShardParamValue", "SQL ["
//                            + parseInfo.getSQL() + "] Query without shard parameter: " // NL
//                            + column.getSql(), null);
//                }
//
//            }
//            return value;
//        } else {
//
//            // 如果针对该列进行散表，则必须包含该列作为查询条件。
//            throw new BadSqlGrammarException("interpreter.findShardParamValue", "SQL ["
//                    + parseInfo.getSQL() + "] Query without shard parameter: " // NL
//                    + column.getSql(), null);
//        }
//
//    }
//
//    public RoutingConfigurator getRoutingConfigurator() {
//        return routingConfigurator;
//    }
//
//    public void setRoutingConfigurator(RoutingConfigurator routingConfigurator) {
//        this.routingConfigurator = routingConfigurator;
//    }
// }
